var total_keyword = 7;
var cur_keyword = 0;
var keyword = new Array(total_keyword);
var naver_key = '';
var err_msg = '네이버 오픈API 키를 발급 받으셔야 합니다.<br>openapi.naver.com/register.nhn<br>위의 네이버 OpenAPI 사이트에서 키를 발급 받으신 후, 키를 복사하여 설정에서 입력하세요.';  	

keyword[0] = new Array('people',	'인물');
keyword[1] = new Array('movie', 	'영화');
keyword[2] = new Array('book', 		'도서');
keyword[3] = new Array('game', 		'게임');
keyword[4] = new Array('drama', 	'TV 드라마');
keyword[5] = new Array('broadcast',	'TV 오락프로');
keyword[6] = new Array('perform', 	'공연');

function startWidget()
{
	if(window.widget)
	{
		naver_key  = widget.preferenceForKey("naverkey");
		if(naver_key == '' || naver_key == undefined)
			viewPanel(0);
	}	 
	 
	getNaverData();	
}

function saveNaverKey()
{
	var obj = document.getElementById("naver_key");

	if(obj.value)
	{
	 	if(window.widget)
		{
			naver_key = obj.value;
			widget.setPreferenceForKey(naver_key, "naverkey");
			viewPanel(1);
			getNaverData();
		}
	}
}

function viewPanel(idx)
{
	if(idx == 0)
	{
		document.getElementById('content').style.display = 'none';
		document.getElementById('setup').style.display = 'block';
		
		document.getElementById('category').innerHTML = "Setup";
		document.getElementById('key_info').innerHTML = err_msg;
	}
	else
	{
		document.getElementById('content').style.display = 'block';
		document.getElementById('setup').style.display = 'none';
	}
}

function resultFromNaver(mm)
{
	if(document.getElementById('content').style.display == 'none')
		return;

    var error = mm.responseXML.getElementsByTagName("error")[0];
	if(error)
	{
		var message = error.getElementsByTagName("message")[0].firstChild.nodeValue;
		
		document.getElementById('category').innerHTML = "Error";
		document.getElementById('rank1').innerHTML = message;
		document.getElementById('rank2').innerHTML = err_msg;

		for(i = 3; i <= 10; i++)
		{
			document.getElementById('rank'+i).innerHTML = '';
		}
		return;
	}
	
    var result = mm.responseXML.getElementsByTagName("result")[0];
    var items = result.getElementsByTagName("item")[0];
	
	document.getElementById('category').innerHTML = ':: Naver ' + keyword[cur_keyword][1] + ' 인기 검색어'; 
	for(i = 1; i <= 10; i++)
	{	
    	var rr = items.getElementsByTagName('R' + i)[0];

		var title = rr.getElementsByTagName("K")[0].firstChild.nodeValue;
		var state = rr.getElementsByTagName("S")[0].firstChild.nodeValue;
		var count = rr.getElementsByTagName("V")[0].firstChild.nodeValue;
	
		var text = '';
		var st = '';
		var cls = '';
		
		text = '<div class="box">' + i + '</div>';
		text += title;
		if(state == '-')
		{
			cls = 'st_down';
			st = 'down';
		}	
		else if(state == '+')
		{
			cls = 'st_up';
			st = 'up';
		}	
		else
		{
			cls = 'st_new';
			st = 'new';
		}	
		text += ('<sup class=' + cls + '>');
		text += st;
		text += '</sup>';
		
		document.getElementById('rank' + i).innerHTML = text;
	}

	cur_keyword++;
	if(cur_keyword >= total_keyword)
		cur_keyword = 0;

}

function getNaverData()
{
    if(naver_key)
	{
		var ob = new XMLHttpRequest();
    	var url = "http://openapi.naver.com/search?key=" + naver_key + "&target=ranktheme&query=" + keyword[cur_keyword][0]; 

	    if(ob == null)
        	return;

   		ob.open("GET", url, false); 
    	ob.send("");

		if(ob.readyState == 4)
		{
			if(ob.status == 200)
			{
				resultFromNaver(ob);
			}
		}
	}	

	setTimeout("getNaverData()", 5000);
}

